function RsxComunication(iMessageHandler) 
{	
	this.iMsgH = iMessageHandler;
	
	this.ch_join_compliant = function(s) 
	{
		var r = "";
		for (var i = 0; i < s.length; i++) 
		{
			if (s.charAt(i) == '\n')
			{
				r += "\\n";
				continue;
			}
			if (s.charAt(i) == '\r')
			{
				r += "\\r";
				continue;
			}
			if (s.charAt(i) == '\t') 
			{
				r += "\\t";
				continue;
			}
			r += s.charAt(i);
		}
		return r;
	};
}

RsxComunication.MSG_NATIVI_RX = 
{
	RSX_ENGINE_STOP: 'RSX_ENGINE_STOP',
	GPS_STREET_NAME: 'GPS_STREET_NAME',
	LAST_GPS_POSITION: 'LAST_GPS_POSITION',
	GPS_ERROR: 'GPS_ERROR',
	ERROR_SOCKET: 'ERROR_SOCKET',
	DEBUG_MSG: 'DEBUG_MSG',
	ELENCO_PIAZZOLE: 'ELENCO_PIAZZOLE',
	UPDATE_FLOTTA: 'UPDATE_FLOTTA',
	UPDATE_POSIZIONE_VEICOLO: 'UPDATE_POSIZIONE_VEICOLO',
	MAP_CLOSED: 'MAP_CLOSED',
	RECEIVE_SOCKET: 'RECEIVE_SOCKET',
	RX_BYTES: 'RX_BYTES',
	TX_BYTES: 'TX_BYTES',
	UPDATE_MAP_POSITION: 'UPDATE_MAP_POSITION',
	DEVICE_TOKEN: 'DEVICE_TOKEN',
	OAUTH : 'OAUTH',
	PUSH_MESSAGE: 'PUSH_MESSAGE',
	PAYPAL_SUCCESS: 'PAYPAL_SUCCESS',
	PAYPAL_FAILED: 'PAYPAL_FAILED',
	PAYPAL_CANCELLED: 'PAYPAL_CANCELLED',
	GPS_ENABLED: 'GPS_ENABLED',
	COLLECT_INFO: 'COLLECT_INFO',
	CHECK_NOTIFICHE_PUSH: 'CHECK_NOTIFICHE_PUSH',
	SYSTEM_EVENT: 'SYSTEM_EVENT',
	WRITE_TO_LOG: 'WRITE_TO_LOG',
};

RsxComunication.MSG_NATIVI_TX = 
{
	SEND_SOCKET: 'SEND_SOCKET',
	SHOW_MAP: 'SHOW_MAP',
	SHOW_MAP_CLIENTE: 'SHOW_MAP_CLIENTE',
	SHOW_MAP_CLIENTE_TAXI: 'SHOW_MAP_CLIENTE_TAXI',
	CLOSE_ACTIVITY: 'CLOSE_ACTIVITY',
	LAST_GPS_POSITION: 'LAST_GPS_POSITION',
	BRING_FOREGROUND: 'BRING_FOREGROUND',
	DEVICE_TOKEN: 'DEVICE_TOKEN',
	OAUTH: 'OAUTH',
	GPS_SETTINGS: 'GPS_SETTINGS',
	QUIT: 'QUIT',
	BEEP: 'BEEP',
	PLAY_WAVE: 'PLAY_WAVE',
	STOP_WAVE: 'STOP_WAVE',
	INVALIDATE_WEBVIEW: 'INVALIDATE_WEBVIEW',
	MOVE_FIX_WEBVIEW: 'MOVE_FIX_WEBVIEW',
	GPS_ENABLED: 'GPS_ENABLED',
	COLLECT_INFO: 'COLLECT_INFO',
	CLOSE_SOCKET: 'CLOSE_SOCKET',
	UPDATE_FLOTTA: 'UPDATE_FLOTTA',
	UPDATE_POSIZIONE_VEICOLO: 'UPDATE_POSIZIONE_VEICOLO',
	CHECK_NOTIFICHE_PUSH: 'CHECK_NOTIFICHE_PUSH',
	PREVENT_SLEEP: 'PREVENT_SLEEP',
	ORIENTATION: 'ORIENTATION',
	RELOAD: 'RELOAD',
};

RsxComunication.prototype.service = function($action, $dati)
{
	if ('plugins' in window && 'microtek' in window.plugins)
	{					
		window.plugins.microtek.genericMsg($action, $dati);
	}
};

RsxComunication.prototype.send = function($connection, $dati)
{	
	$dati = JSON.stringify($dati);
	
	Debug.Log(">> " + $dati);
	Logger.log(Logger.VERBOSE, ">> " + $dati);
	
	this.service(RsxComunication.MSG_NATIVI_TX.SEND_SOCKET, {"ip": $connection.ip, "port" : $connection.porta, "timeout" : $connection.timeout, "data" : $dati});
};

RsxComunication.prototype.sendAndWait = function($connection, $dati) 
{	
	this.iMsgH.In_attesa_di_risposta($dati.tipo, $dati.id);
	
	this.send($connection, $dati);
};


RsxComunication.prototype.sendWeb = function($url, $dati, onSuccess, onFail, onException) 
{			       		
	var $clean = JSON.stringify($dati);
	
	Debug.Log("AJAX >>: " + $clean);						
		
	var binaryString = pako.deflate($clean, { to: 'string' });	
	
	var compressed = btoa(binaryString);		
	
	compressed = { data: compressed };
	
	$.ajax({
		url: $url,
		type: 'post',
		dataType: 'json',
		cache: false,  
		success: function (json) 
		{   			
			try
			{									
				var compressData = atob(json.data);								
				
				var rxMsg = pako.inflate(compressData, { to: 'string' });							
				
				Debug.Log("AJAX <<: " + rxMsg);
					
				rxMsg = JSON.parse(rxMsg);								
				
				if (onSuccess !== null)
				{
					onSuccess(rxMsg);
				}
			}
			catch(err)
			{
				Debug.Log("AJAX EXCEPTION: " + err);
				
				if (onException !== null)
				{
					onException(err);
				}
			}						
		},
		error: function( jqXHR, textStatus, errorThrown) 
		{   
			Debug.Log("AJAX ERROR: [" + errorThrown + "] - [" + textStatus + "]");
			
			if (onFail !== null)
			{
				onFail(jqXHR, textStatus, errorThrown);
			}
		},
		data: compressed
	});	
};

RsxComunication.prototype.parser = function($action, $msg)
{			
	try
	{
		if ($action != RsxComunication.MSG_NATIVI_RX.DEBUG_MSG)
		{
			Debug.SystemLog("$$: " + "[" + $action + "] " + $msg);
		}
		
		do
		{									
			if ($action == RsxComunication.MSG_NATIVI_RX.RSX_ENGINE_STOP && $msg == 'true')
			{
				this.iMsgH.OnEngineStop();
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.UPDATE_MAP_POSITION)
			{
				var $data = JSON.parse(this.ch_join_compliant($msg));
				this.iMsgH.OnUpdateMapPosition($data);
				break;
			}	
			
			if ($action == RsxComunication.MSG_NATIVI_RX.GPS_STREET_NAME)
			{
				var $data = JSON.parse(this.ch_join_compliant($msg));							
				this.iMsgH.OnGpsStreetName($data);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.LAST_GPS_POSITION && $msg !== '')
			{
				var $data = JSON.parse(this.ch_join_compliant($msg));							
				this.iMsgH.OnLastGpsPostion($data);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.GPS_ERROR)
			{											
				this.iMsgH.OnGpsError($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.ERROR_SOCKET)
			{											
				this.iMsgH.OnErrorSocket($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.DEBUG_MSG)
		    {
				this.iMsgH.OnDebugMsg($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.ELENCO_PIAZZOLE)
		    {
				this.iMsgH.OnElencoPiazzole($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.UPDATE_FLOTTA)
		    {
				this.iMsgH.OnUpdateFlotta($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.UPDATE_POSIZIONE_VEICOLO)
			{
				this.iMsgH.OnUpdatePosizioneVeicolo($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.MAP_CLOSED)
			{					
				this.iMsgH.OnMapClosed($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.RX_BYTES)
		    {
				this.iMsgH.OnRxBytes($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.RECEIVE_SOCKET)
		    {
				Debug.Log("<< " + "[" + $action + "] " + $msg);
				Logger.log(Logger.VERBOSE, "<< " + "[" + $action + "] " + $msg);
				
				var $data = JSON.parse(this.ch_join_compliant($msg));
				
				this.iMsgH.Esito_in_attesa_di_risposta($data.tipo);
				this.iMsgH.OnReceiveSocket($data);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.TX_BYTES)
		    {
				this.iMsgH.OnTxBytes($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.DEVICE_TOKEN)
			{
				this.iMsgH.OnDeviceToken($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.OAUTH)
			{
				this.iMsgH.OnOAuth($msg);
				break;
			} 
			
			if ($action == RsxComunication.MSG_NATIVI_RX.PUSH_MESSAGE)
			{							
				this.iMsgH.OnPushMessage($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.PAYPAL_SUCCESS)
			{
				var $data = JSON.parse(this.ch_join_compliant($msg));
				this.iMsgH.OnPayPalSuccess($data);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.PAYPAL_FAILED)
			{
				var $data = JSON.parse(this.ch_join_compliant($msg));
				this.iMsgH.OnPayPalFailed($data);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.PAYPAL_CANCELLED)
			{
				var $data = JSON.parse(this.ch_join_compliant($msg));
				this.iMsgH.OnPayPalCancelled($data);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.COLLECT_INFO)
			{
				this.iMsgH.OnCollectInfo($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.CHECK_NOTIFICHE_PUSH)
			{
				this.iMsgH.OnCheckNotifichePush($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.GPS_ENABLED)
			{
				this.iMsgH.OnGpsEnabled($msg);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.SYSTEM_EVENT)
			{
				var $data = JSON.parse(this.ch_join_compliant($msg));
				this.iMsgH.OnSystemEvent($data);
				break;
			}
			
			if ($action == RsxComunication.MSG_NATIVI_RX.WRITE_TO_LOG)
			{				
				this.iMsgH.OnWriteToLog($msg);
				break;
			}
			
		} while (false);						
	} 
	catch(err)
	{		
		Debug.Log('!! [' + err.name + '] - [' + err.message + ']');		
		this.iMsgH.OnException(err);		
	}
};