$.paypal = $.extend({	    
    onSuccesfulPayment : function(payment) {
      Debug.Log("payment success: " + JSON.stringify(payment, null, 4));
    },
    onFuturePaymentAuthorization : function(authorization) {
      Debug.Log("authorization: " + JSON.stringify(authorization, null, 4));
    },
    createPayment : function () {
      // for simplicity use predefined amount
      var paymentDetails = new PayPalPaymentDetails($.paypal.configuration.price, "0.0", "0.0");
      var payment = new PayPalPayment($.paypal.configuration.price, "EUR", $.paypal.configuration.description, "Sale", paymentDetails);
      return payment;
    },    
    onPrepareRender : function() {      
      PayPalMobile.renderSinglePaymentUI($.paypal.createPayment(), $.paypal.callback, $.paypal.onUserCanceled);
    },
    onPayPalMobileInit : function() {
      // must be called
      // use PayPalEnvironmentNoNetwork mode to get look and feel of the flow
      // PayPalEnvironmentProduction
      // for more options see `paypal-mobile-js-helper.js`
      var config = new PayPalConfiguration({
    	  merchantName: $.paypal.configuration.radiotaxi, 
    	  defaultUserEmail: $.paypal.configuration.email,
    	  languageOrLocale: $.paypal.configuration.language,
    	  acceptCreditCards: false,
      });
    	
      var environment = "PayPalEnvironmentProduction";
      if (Debug.On())
      {
    	  environment = "PayPalEnvironmentSandbox";
      }
      
      PayPalMobile.prepareToRender(environment, config, $.paypal.onPrepareRender);
    },
    onUserCanceled : function(result) {
    	Debug.Log(result);
    },	
    pay: function(clientId, sandBoxId, price, description, radiotaxi, email, language, callback)
    { 
    	var clientIDs = {
    			"PayPalEnvironmentProduction": clientId,
    			"PayPalEnvironmentSandbox": sandBoxId
        };
    	
    	$.paypal.callback = callback;
    	
    	$.paypal.configuration.price = price;
    	$.paypal.configuration.description = description;
    	$.paypal.configuration.radiotaxi = radiotaxi;
    	$.paypal.configuration.email = email;
    	$.paypal.configuration.language = language;
    	
    	PayPalMobile.init(clientIDs, $.paypal.onPayPalMobileInit);
    },
    configuration : {
    	price: '',
    	description: '',
        radiotaxi: '',
        email: '',
        language: '',
    },
    callback : null,
}, $.paypal);
