//
//  PushNotification.js
//
// Created by Olivier Louvignes on  2012-05-06.
// Inspired by Urban Airship Inc orphaned PushNotification phonegap plugin.
//
// Copyright 2012 Olivier Louvignes. All rights reserved.
// MIT Licensed

//(function(cordova) {

var MicrotekNS = {

    PushNotification: function() {}
    
};


// Call this to register for push notifications and retreive a deviceToken
MicrotekNS.PushNotification.prototype.registerDevice = function(config, callback) {
    cordova.exec(callback, callback, "PushNotification", "registerDevice", config ? [config] : []);
};

// Call this to retreive pending notification received while the application is in background or at launch
MicrotekNS.PushNotification.prototype.getPendingNotifications = function(callback) {
    cordova.exec(callback, callback, "PushNotification", "getPendingNotifications", []);
};

// Call this to get a detailed status of remoteNotifications
MicrotekNS.PushNotification.prototype.getRemoteNotificationStatus = function(callback) {
    cordova.exec(callback, callback, "PushNotification", "getRemoteNotificationStatus", []);
};

// Call this to get the current value of the application badge number
MicrotekNS.PushNotification.prototype.getApplicationIconBadgeNumber = function(callback) {
    cordova.exec(callback, callback, "PushNotification", "getApplicationIconBadgeNumber", []);
};

// Call this to set the application icon badge
MicrotekNS.PushNotification.prototype.setApplicationIconBadgeNumber = function(badge, callback) {
    cordova.exec(callback, callback, "PushNotification", "setApplicationIconBadgeNumber", [{badge: badge}]);
};

// Call this to clear all notifications from the notification center
MicrotekNS.PushNotification.prototype.cancelAllLocalNotifications = function(callback) {
    cordova.exec(callback, callback, "PushNotification", "cancelAllLocalNotifications", []);
};

// Call this to retreive the original device unique id
// @warning As of today, usage is deprecated and requires explicit consent from the user
MicrotekNS.PushNotification.prototype.getDeviceUniqueIdentifier = function(callback) {
    cordova.exec(callback, callback, "PushNotification", "getDeviceUniqueIdentifier", []);
};

// Event spawned when a notification is received while the application is active
MicrotekNS.PushNotification.prototype.notificationCallback = function(notification) {
    Debug.Log(JSON.stringify(['push-notification!', notification]));
    if (this.onNotification)
    {
        this.onNotification(notification);
    }
};

MicrotekNS.PushNotification.prototype.registerNotificationCallback = function(f)
{
    this.onNotification = f;
};

	//cordova.addConstructor(function() {
	//	if(!window.plugins) window.plugins = {};
	//	window.plugins.pushNotification = new PushNotification();
	//});

//})(window.cordova || window.Cordova);

function initPushNotificationPlugin()
{
    if(!window.plugins) {
        window.plugins = {};
    }
    
	window.plugins.pushNotification = new MicrotekNS.PushNotification();
}