function Agent() 
{
	if (window === this) 
	{
		return new Agent();
	}
	
	return this;
}

Agent.isChronium = function()
{
	return /chrome/.test(navigator.userAgent.toLowerCase());
};

Agent.isAndroid = function()
{	
	return navigator.userAgent.match(/Android/i);
};

Agent.badAndroidBrowser = function()
{
	return (this.isAndroid() && !this.isChronium());
};

Agent.isIos = function()
{
	return ((/iphone|ipod|ipad/gi).test(navigator.platform));	  
};

Agent.isIpad = function()
{
	return ((/ipad/gi).test(navigator.platform));	 
};

Agent.isWindows = function ()
{
    return navigator.userAgent.match(/Windows Phone/i);
};

Agent.isBrowser = function()
{
	return (!this.isAndroid() && !this.isIos() && !this.isWindows());
};

Agent.devicePlatform = function()
{
	if (window.device !== null && 
		typeof window.device != 'undefined' && 
		'platform' in window.device && 
		window.device.platform !== null)
	{			  
	   return window.device.platform;
	}
	return 'unknown';
};

Agent.deviceUuid = function()
{
	if (window.device !== null && 
		typeof window.device != 'undefined' && 
		'uuid' in window.device && 
		window.device.uuid !== null)
	{			  
	   return window.device.uuid;
	}
	return 'unknown';
};