var Keyboard = (function() 
{
	var context = {};
	
	var registeredEvents = false;
	var onShowCallback = null;
	var onHideCallback = null;
	
	context.show = function()
	{
		if (typeof cordova != 'undefined' && 'Keyboard' in cordova.plugins)
		{
			registerEvents();
			
    		cordova.plugins.Keyboard.show();
		}
	};
	
	context.close = function()
	{
		if (typeof cordova != 'undefined' && 'Keyboard' in cordova.plugins)
		{
			registerEvents();
			
    		cordova.plugins.Keyboard.close();
		}
	};
	
	context.visible = function()
	{
		if (typeof cordova != 'undefined' && 'Keyboard' in cordova.plugins)
		{
			return cordova.plugins.Keyboard.isVisible;
		}
		return false;
	};
	
	context.onceShow = function(_callback)
	{
		onShowCallback = _callback;
	};
	
	context.onceHide = function(_callback)
	{
		onHideCallback = _callback;
	};
	
	var registerEvents = function()
	{
		if (!registeredEvents)
		{
			registeredEvents = true;
			
			window.addEventListener('native.keyboardhide', hideHandler);
			window.addEventListener('native.keyboardshow', showHandler);
		}
	};		
	
	var hideHandler = function(e)
	{
		if (onHideCallback !== null)
		{
			onHideCallback(e);
			
			onHideCallback = null;
		}
	};
	
	var showHandler = function(e)
	{
		if (onShowCallback !== null)
		{
			onShowCallback(e);
			
			onShowCallback = null;
		}
	};
	
	return context;
})();