var Localize = (function(_map) 
{
	var context = {};
	
	var map = _map;
	var current = 'it_it';
	var def = 'it_it';
	
	context.updateMap = function(_map)
	{
		map = _map;
	};
	
	context.init = function(_default)
	{		
		current = _default;
		def = _default;
		
		this.setLang(this.getSystemLang());
	};
	
	context.setLang = function(language)
	{			
		if (language.length == 2)
		{
			language = language + "_" + language;
		}	
		if (language == 'en_en' || language == 'en_gb')
		{
			language = 'en_us';
		}		
		current = language in map ? language : def;		
	};
	
	context.getLang = function()
	{
		return current;
	};
	
	context.getShortLang = function()
	{
		return current.substring(0, 2);
	};
	
	context.getSystemLang = function()
	{
		var language = current;
		if ('language' in navigator)
		{
			language = navigator.language.replace('-', '_').toLowerCase();
		}
		return language;
	};
	
	context.get = function(key)
	{	
		var s;
		try
		{			
			s = map[current][key];			
		}
		catch(err)
		{
			s = null;
		}
		if (s === null || s === undefined)
		{
			s = map['it_it'][key];
		}
		return s;
	};
	
	context.localize = function()
	{		
		var me = this;
		$('span.l').each(function()
		{					
			$(this).html(me.get($(this).attr('title')));		  
		});
		$(':input').each(function()
		{
			$(this).attr('placeholder', me.get($(this).attr('placeholder')));
		});
	};	
	
	return context;
})({ it_it : {}, de_de : { }, en_us : { } });

// Funzione globale di comodo
function __(key)
{
	return Localize.get(key);
}