var Navigator = (function(_forms, debug, _logger) 
{
	var context = {};
	
	var forms = _forms;
	var logger = _logger;
	var exceptionCallback = null;
	var navigationCallback = null;
	
	context.Go = function(event, data)
	{	
		//debug.Log('Nav: ' + event.type + ' - ' + event.target.id);		
		logger.log(logger.VERBOSE, 'Nav: ' + event.type + ' - ' + event.target.id);		
		
		try
		{							
			if (event.target.id in forms)
			{
				if (event.type in forms[event.target.id])
				{							
					forms[event.target.id][event.type](event, data);				
				}
			}			
			
			if (navigationCallback !== null)
			{
				navigationCallback(event, data);
			}
		}
		catch(err)
		{					
			debug.Log('Navigator !! [' + err.name + '] - [' + err.message + ']');
			logger.log(logger.VERBOSE, 'Navigator !! [' + err.name + '] - [' + err.message + ']');
			
			if (exceptionCallback !== null)
			{
				exceptionCallback(err);
			}
		}
	};
	
	context.SetExceptionCallback = function(_callback)
	{
		exceptionCallback = _callback;
	};
	
	context.SetNavigationCallback = function(_callback)
	{
		navigationCallback = _callback;
	};
	
	return context;
	
})($.forms, Debug, Logger);

$(document).on('pagebeforechange', function(event, data)      
{  	
	if ($.callbacks.navigator_page_change_callback !== null)
	{
		$.callbacks.navigator_page_change_callback(event, data);
	}
});

$(document).on('pagebeforecreate', function(event, data)      
{  	
	Navigator.Go(event, data);	   	
});

$(document).on('pagebeforeshow', function(event, data)      
{  	
	Navigator.Go(event, data);	
});

$(document).on('pageshow', function(event, data)      
{  			
	Navigator.Go(event, data);		
});

$(document).on('pagebeforehide', function(event, data)      
{  				
	Navigator.Go(event, data);	
});

$(document).on('pageinit', function(event, data)      
{  		
	Navigator.Go(event, data);	
});