function Routing(_engine) 
{			
	this.backPage = null;
	this.previuosBackPage = null;
	this.pagina_da_ricaricare = null;
	this.engine = _engine;
	
	// Abstract
	this.getDefaultRoute = function() { return null; };
	this.getReloadRoute = function() { return null; };
}

Routing.prototype.setBackPage = function(backPage)
{
  if (this.backPage != backPage)
  {
	  this.previuosBackPage = this.backPage;
  }
  this.backPage = backPage;	  
};

Routing.prototype.getBackPage = function()
{
	return this.backPage;
};

Routing.prototype.getPreviusBackPage = function()
{
	return this.previuosBackPage;
};

Routing.prototype.goPreviusPage = function() 
{			
	this.changePage(this.previuosBackPage);		
};

Routing.prototype.goBackPage = function() 
{		
	if (this.backPage === null) 
	{
		this.backPage = this.getDefaultRoute();
	}
	this.changePage(this.backPage);		
};

Routing.prototype.dialog = function($page)
{
	this.engine.changePage($page, { role : 'dialog' });
};

Routing.prototype.reload = function()
{		
	var activePage = this.getActivePage();
			
	this.pagina_da_ricaricare = activePage + '.html';
    this.engine.changePage(this.getReloadRoute());	    
};

Routing.prototype.getActivePage = function()
{
	return this.engine.activePage.attr('id');
};

Routing.prototype.changePage = function($page) 
{				
	var $pageId = $page.search('.html');

	if ($pageId != -1 && this.engine.activePage.attr('id') == $page.substring(0, $pageId)) 
	{
		this.reload();
	} 
	else 
	{
		this.engine.changePage($page);
	}		
};

Routing.prototype.goDefaultPage = function()
{
	this.changePage(this.getDefaultRoute());	
};