var Scroll = (function(_agent, _keyboard) 
{
	var context = {};
	
	var scroll = null;
	
	var agent = _agent;
	var keyboard = _keyboard;

	context.build = function(wrapper)
	{		
		if (scroll !== null) 
		{
			scroll.destroy();
			scroll = null;
		}			

		scroll = new IScroll(wrapper, 
		{
			click: agent.isChronium(), /* Andrebbe solo per Chromiun */	
			tap: 'scrollTap'
		});				

		var me = this;
		
		$(wrapper).on('scrollTap', function (e, eventName) 
		{
			var target = e.target;	        	

			if ( !(/(SELECT|INPUT|TEXTAREA)/i).test(target.tagName) ) 
			{	   				
				keyboard.close();
				var elements = ['input', 'select', 'textarea'];
				for(i = 0; i < elements.length; ++i)
				{
					if ($(elements[i] + ':focus').length > 0)
					{
						$(elements[i] + ':focus').blur();
						break;
					}
				}
			}
			else
			{	
				//console.log(target);
				//console.log(Object.getOwnPropertyNames(target));
				
				if ('mobiscroll' in $(target))
				{						
					if ('id' in target && target.id.indexOf('_dummy'))
					{
						$('#' + target.id.replace('_dummy', '')).mobiscroll('show', true, false);
					}
					else
					{
						$(target).mobiscroll('show', true, false);
					}
				}
					
			    me.tap(e, eventName);				
			}
		});
	};

	context.refresh = function()
	{
		setTimeout(function () 
		{
			if (scroll !== null)
			{
				scroll.refresh();
			}
		}, 0);
	};
	
	context.scrollTo = function(element)
	{
		if (scroll !== null)
		{
			scroll.scrollToElement(element);
		}
	};
	
	context.tap = function(e, eventName)
	{
		var ev = document.createEvent('Event');
		ev.initEvent(eventName, true, true);
		ev.pageX = e.pageX;
		ev.pageY = e.pageY;
		e.target.dispatchEvent(ev);
	};
	
	return context;
})(Agent, Keyboard); 