function Validator() 
{
	if (window === this) 
	{
		return new Validator();
	}
	
	return this;
}

Validator.IsEmail = function(email)
{	
	var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	return regex.test(email);		
};

Validator.Price = function(price)
{
	var regex = /^\d+(,\d{0,2})$/;
	return regex.test(price);			
};

Validator.DecimalNumber = function(number)
{
	var regex = /^[0-9]+([\,|\.][0-9]+)?$/;	
	return regex.test(number);
};

Validator.CodiceAddebito = function(ccc)
{
	var regex = /^([a-zA-Z0-9./-])+$/;
	return regex.test(ccc);
};

Validator.PaddingZero = function(num, size) 
{
    var s = num + "";
    while (s.length < size) s = "0" + s;
    return s;
}

Validator.Json = function(str)
{
	if (str == 'null')
	{
		return false;
	}
	
	try 
	{
        JSON.parse(str);
    } 
	catch (e) 
	{
        return false;
    }
	
    return true;
};
