(function() {
    'use strict';

    var servicesModule = angular.module('myApp.services');

    servicesModule.service('addressTypeSelection', function ($ionicModal, $q) {

        var modalPage;
        var typePromise;

        var STREET_NUMBER_TYPES = {
            BLACK: 'BLACK',
            RED: 'RED',
        };

        this.create = function(scope) {

            if(modalPage) {
                return;
            }

            $ionicModal.fromTemplateUrl('templates/address-type-selection/address-type-selection.html', {
                scope: scope
            }).then(function (modal) {

                modalPage = modal;
                modalPage.selectType = function (type) {
                    this.hide().then(function () {
                        typePromise.resolve(type);
                    });
                };
                modalPage.STREET_NUMBER_TYPES = STREET_NUMBER_TYPES;

                scope.addressTypeModal = modalPage;
            });

            scope.$on('$destroy', function() {
                modalPage.remove();
                modalPage = undefined;
                typePromise = undefined;
            });
        };

        this.chooseType = function() {
            typePromise = $q.defer();
            modalPage.show();

            return typePromise.promise;
        };

    });
})();