(function() {
    'use strict';

    angular
        .module('myApp.services')
        .service('test', function IubendaService($rootScope, $q, $interval, uiState) {
            /* Setup */

            var CONSTANTS = {
                WAIT_INTERVAL: 200,
            };

            /* Service */

            angular.extend(this, {
                run: run,
            });

            /* Service methods */

            function run() {
                testUserRegistrationFromScratch();
            }

            /* Single test end to end */

            function testUserRegistrationFromScratch() {
                waitToBeInRegistrationPage()
                .then(fillRegistrationFields)
                .then;
            }

            /* Utils */

            function waitToBeInRegistrationPage() {

                var deferred = $q.defer();

                var wait = $interval(function() {

                    if(uiState.is('registration')) {
                        $interval.cancel(wait);
                        deferred.resolve();
                    }

                }, CONSTANTS.WAIT_INTERVAL);

                return deferred.promise;

            }

            function fillRegistrationFields() {
                angular.element(document.querySelector("#user input")).val("Andrea");
                angular.element(document.querySelector("#user input:last-child")).val("Baliello");
                angular.element(document.querySelector("#phoneNumber input")).val("3935343980");
                angular.element(document.querySelector("input#email")).val("andreab@utek.local");
                angular.element(document.querySelector("label.toggle input")).prop("checked", true);
            }

            /* Init */

            (function init() {})();
        });
})();
